{% extends "combio_app/base.html" %}
{% load i18n %}
{% load static %}
{% block container %}
{% block style %}
<style>
  body {
    background-color: #006464;
  }

  em {
    color: red;
  }

  .active {
    background-color: #006464;
    color: #50fa96;
  }

  [v-cloak] {
    display: none;
  }
</style>
<script>
  csrfToken = "{{ csrf_token }}";
  staffUser = "{{ request.user.is_superuser }}";
</script>
{% endblock %}
{% verbatim %}
<div class="grid grid-cols-12 min-h-[50%] w-full place-items-stretch place-content-stretch" id="app" style="">
  <div class="col-span-12 grid w-full p-6 bg-stone-300 border-b border-mpiwg-subdued-green">
    <div class="relative">
      <div class="absolute inset-y-0 left-0 flex items-center pl-3 pointer-events-none">
        <svg aria-hidden="true" class="w-5 h-5 text-gray-500" fill="none" stroke="currentColor" viewBox="0 0 24 24"
          xmlns="http://www.w3.org/2000/svg">
          <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
            d="M21 21l-6-6m2-5a7 7 0 11-14 0 7 7 0 0114 0z"></path>
        </svg>
      </div>
      <input v-model="q" type="search" id="default-search"
        class="w-full p-4 pl-10 text-gray-900 border border-gray-300 rounded bg-gray-50 focus:ring-mpiwg-green focus:border-mpiwg-green"
        placeholder="Search Oral Histories" @change="submitForm();currentPage=1" @focus="searchFocus=true"
        @blur="searchFocus=false" ref="input" />
      <div class="absolute right-2.5 bottom-2.5 w-50">
        <button v-on:click="submitForm();currentPage=1"
          class="text-white shadow-md shadow-inner bg-mpiwg-green hover:bg-mpiwg-light-green hover:text-mpiwg-green focus:ring-4 focus:outline-none focus:mpiwg-green font-medium rounded text-sm px-4 py-2 mr-2">
          Search
        </button>
        <button @click="resetForm()"
          class="text-white shadow-md shadow-inner bg-mpiwg-green hover:bg-mpiwg-light-green hover:text-mpiwg-green focus:ring-4 focus:outline-none focus:mpiwg-green font-medium rounded text-sm px-4 py-2">
          <i title="reset the search" class="cursor-pointer fa-arrow-rotate-right fa-solid fa-xs"></i> Reset search
        </button>
      </div>
    </div>
  </div>
  <div class="col-span-4 min-w-96 border-r border-mpiwg-beige font-sans p-6 h-full w-full bg-mpiwg-brown text-mpiwg-green">

    <div class="p-2 bg-mpiwg-beige text-sm text-mpiwg-green shadow-md shadow-inner rounded-t" v-if="!loading">
      <div>
        <div class="hover:cursor-pointer" @click="toggleCollectionFilter()"><i class="fa-solid fa-xs"
            :class="[showCollectionFilter ? 'fa-chevron-down' : 'fa-chevron-right']"></i> Filter by collections</div>
        <hr class="bg-mpiwg-subdued-green border-0 h-px my-2" :class="[showCollectionFilter ? '' : 'hidden']" />
        <div :class="[showCollectionFilter ? '' : 'hidden']" class="transition-all">
          <div v-for="collection in collections" class="flex mb-2">
            <div class="flex items-center h-5">
              <input type="checkbox" v-model="collection.checked" :value="collection.pk" :name="collection.pk"
                :id="collection.pk" @change="submitForm();currentPage=1"
                class="mt-[0.15rem] mr-2 h-[1.125rem] w-[1.125rem] appearance-none rounded-[0.25rem] border-[0.125rem] border-solid border-neutral-300 outline-none before:pointer-events-none before:absolute before:h-[0.875rem] before:w-[0.875rem] before:scale-0 before:rounded-full before:bg-transparent before:opacity-0 before:shadow-[0px_0px_0px_13px_transparent] before:content-[''] checked:border-mpiwg-green checked:bg-mpiwg-green checked:before:opacity-[0.16] checked:after:absolute checked:after:ml-[0.25rem] checked:after:-mt-px checked:after:block checked:after:h-[0.8125rem] checked:after:w-[0.375rem] checked:after:rotate-45 checked:after:border-[0.125rem] checked:after:border-t-0 checked:after:border-l-0 checked:after:border-solid checked:after:border-white checked:after:bg-transparent checked:after:content-[''] hover:cursor-pointer hover:before:opacity-[0.04] hover:before:shadow-[0px_0px_0px_13px_rgba(0,0,0,0.6)] focus:shadow-none focus:transition-[border-color_0.2s] focus:before:scale-100 focus:before:opacity-[0.12] focus:before:shadow-[0px_0px_0px_13px_rgba(0,0,0,0.6)] focus:before:transition-[box-shadow_0.2s,transform_0.2s] focus:after:absolute focus:after:z-[1] focus:after:block focus:after:h-[0.875rem] focus:after:w-[0.875rem] focus:after:rounded-[0.125rem] focus:after:content-[''] checked:focus:before:scale-100 checked:focus:before:shadow-[0px_0px_0px_13px_#3b71ca] checked:focus:before:transition-[box-shadow_0.2s,transform_0.2s] checked:focus:after:ml-[0.25rem] checked:focus:after:-mt-px checked:focus:after:h-[0.8125rem] checked:focus:after:w-[0.375rem] checked:focus:after:rotate-45 checked:focus:after:rounded-none checked:focus:after:border-[0.125rem] checked:focus:after:border-t-0 checked:focus:after:border-l-0 checked:focus:after:border-solid checked:focus:after:border-white checked:focus:after:bg-transparent">
            </div>
            <div class="ms-2 text-sm">
              <label :for="collection.pk"
                class="text-gray-900 hover:cursor-pointer">{{collection.name}}</label>
              <p id="helper-checkbox-text" class="text-xs font-normal text-gray-500">
                {{collection.nr_records}} records <a :href="collection.link" class="underline" target="_blank">more
                  info</a></p>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      class="p-2 bg-mpiwg-beige text-sm text-mpiwg-green shadow-md shadow-inner rounded-b border-0 border-t border-mpiwg-brown"
      v-if="!loading">
      <div>
        <div class="hover:cursor-pointer" @click="toggleFilterBookmarks()">
          <i title="show bookmarks only" class="cursor-pointer fa-star fa-xs"
            :class="[filterBookmarks ? 'fa-solid' : 'fa-regular']">
          </i> Filter by bookmarked records
        </div>
      </div>
    </div>



    <div
      class="text-center p-2 pb-0 bg-mpiwg-beige text-sm text-mpiwg-green shadow-md shadow-inner rounded-t h-10 mt-4">
      <span class="float-center"><b>{{ total }}</b>
        <span v-if="filterBookmarks"> bookmarked</span> result<span v-if="total > 1">s</span>
      </span>
    </div>

    <div class="w-full flex place-items-stretch place-content-stretch shadow-md text-sm" v-if="total > perPage">
      <pagination :total-pages="totalPages" :total="total" :per-page="perPage" :current-page="currentPage"
        @pagechanged="onPageChange" />
    </div>
    <div>
      <select v-model="sortBy" @change="setSort()"
        class="focus:ring-0 h-10 focus:border-0 focus:border-t focus:border-mpiwg-brown rounded-b h-10 text-sm w-full mb-4 bg-mpiwg-beige border-0 border-t border-mpiwg-brown text-mpiwg-green text-center shadow-md shadow-inner">
        <option class="" v-for="sortOption in sortOptions" :value="sortOption.val">
          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sort by {{ sortOption.label }}
        </option>
      </select>
    </div>
    <div class="m-4 text-center mt-6" v-if="total < 1">No results found.</div>
    <div v-for="(result, index) in results"
      class="p-4 mb-2 py-2 block transition-all cursor-pointer duration-200 font-semibold hover:bg-mpiwg-beige border border-mpiwg-brown hover:text-mpiwg-green hover:shadow-md hover:shadow-inner hover:rounded hover:border hover:border-mpiwg-beige"
      :class="{ 'bg-white hover:bg-white text-mpiwg-green shadow-md shadow-inner rounded border border-mpiwg-beige': isCurrent(result) }"
      :key="result.id" @click="setCurrent(result)">
      <span><i @click="setBookmark(result)" class="fa-star fa-xs mr-1 hover:text-mpiwg-light-green"
          :class="[result.bookmarked ? 'fa-solid' : 'fa-regular']"></i>
        <a @click.self.prevent>{{ result.title }}</a></span>
      <p class="font-light">{{ result.collection.name }}</p>
    </div>
  </div>
  <div class="col-span-8 font-sans w-full h-full bg-white p-4 px-6 pt-5">
    <div class="w-full grid  text-mpiwg-green text-xl h-full place-items-center"
      v-if="!loading && results.length == 0">
      <span><i class="fa-solid fa-vial fa-shake mr-2"></i>No results found. Please
        try another search!</span>
    </div>
    <div v-if="currentResult">
      <div class="mb-4 mt-2">
        <div class="text-xl text-mpiwg-green">
          <i @click="setBookmark(currentResult)" v-if="!loading"
            class="fa-star hover:text-mpiwg-light-green cursor-pointer fa-xs"
            :class="[currentResult.bookmarked ? 'fa-solid' : 'fa-regular']"></i>
          {{currentResult.title}}
        </div>
        <span class="font-light"
          v-if="currentResult && currentResult.collection">{{currentResult.collection.name}}</span>
        <div class="text-base bg-mpiwg-beige my-4 p-4 shadow-inner rounded border border-mpiwg-brown"
          v-if="currentResult.metadata && currentResult.metadata.summary">
          <div class="text-mpiwg-green text-xl mb-2 inline-flex items-center">
            <i class="fa-solid fa-sm fa-clipboard-list mr-1"></i> Summary
          </div>
          <hr class="bg-mpiwg-subdued-green border-0 h-px my-2" />
          <span> {{ currentResult.metadata.summary }} </span>
          <p class="text-xs mt-2 text-mpiwg-green"><i class="fa-solid fa-triangle-exclamation"></i> This summary was
            AI-generated, please interpret with caution!</p>
        </div>
        <div class="bg-mpiwg-beige my-4 p-4 shadow-inner rounded border border-mpiwg-brown"
          v-if="currentResult && currentResult.meta && currentResult.meta.highlight">
          <div class="text-base">
            <div class="text-mpiwg-green text-xl mb-2 inline-flex items-center">
              <i class="fa-solid fa-sm fa-crosshairs mr-1"></i>Hits
            </div>
            <hr class="bg-mpiwg-subdued-green border-0 h-px my-2" />
            <div v-for="(hits, key) in currentResult.meta.highlight" class="text-base" :key="key">
              <span class="text-mpiwg-green">In {{ key }}:&nbsp;</span>
              <div v-for="hit in hits" class="mt-2"><span v-html="hit"></span></div>
              <br />
            </div>
          </div>
        </div>
        <div v-if="total > 0" class="bg-mpiwg-beige p-4 shadow-inner rounded mt-4 border border-mpiwg-brown">
          <div class="text-mpiwg-green text-xl mb-2 inline-flex items-center">
            <i class="fa-solid fa-sm fa-tags mr-1"></i> Metadata
          </div>
          <a v-if="currentResult && currentResult.metadata"
            class="text-white self-center shadow-inner float-right bg-mpiwg-green hover:bg-mpiwg-light-green hover:text-mpiwg-green focus:ring-4 focus:outline-none focus:mpiwg-green font-medium rounded text-sm px-4 py-2"
            style="margin-top: -4px" :href="currentResult.metadata.permalink" target="_blank">
            <i class="fa-solid fa-xs fa-arrow-up-right-from-square mr-2"></i>
            Permalink
          </a>
          <a v-if="staffUser == 'True' && currentResult && currentResult.metadata"
            class="text-white self-center shadow-inner float-right bg-mpiwg-green hover:bg-mpiwg-light-green hover:text-mpiwg-green focus:ring-4 focus:outline-none focus:mpiwg-green font-medium rounded text-sm px-4 py-2"
            style="margin-top: -4px; margin-right: 5px" :href="editLink(currentResult)" target="_blank">
            <i class="fa-solid fa-xs fa-pen-to-square mr-2"></i>
            Complete Metadata
          </a>
          <hr class="bg-mpiwg-subdued-green border-0 h-px my-2 mb-4" />

          <div>

            <div>
              <div>
                <div class="grid grid-cols-12 w-full gap-2">
                  <div class="col-span-6 w-full">
                    <div class="text-base" v-if="currentResult.interviewees">
                      <span class="text-mpiwg-green">Interviewees: </span>
                      <span> {{ currentResult.interviewees.join(", ") }} </span>
                    </div>
                    <div class="text-base" v-if="currentResult.interviewers">
                      <span class="text-mpiwg-green">Interviewers: </span>
                      <span> {{ currentResult.interviewers.join(", ") }} </span>
                    </div>
                    <div class="text-base" v-if="currentResult.participants">
                      <span class="text-mpiwg-green">Participants: </span>
                      <span> {{ currentResult.participants.join(", ") }} </span>
                    </div>
                  </div>
                  <div class="col-span-6 w-full">
                    <div class="text-base" v-if="currentResult.metadata">
                      <span class="text-mpiwg-green">Date: </span>
                      <span>
                        {{ showDate(currentResult.metadata.date) }}
                      </span>
                    </div>
                  </div>
                  <div class="col-span-6 w-full">
                    <div class="text-base" v-if="currentResult.metadata">
                      <span class="text-mpiwg-green">Media Type: </span>
                      <span>
                        {{ currentResult.metadata.media_type }}
                      </span>
                    </div>
                  </div>
                  <div class="col-span-6 w-full">
                    <div class="text-base" v-if="currentResult.metadata && currentResult.metadata.publisher">
                      <span class="text-mpiwg-green">Publisher: </span>
                      <span> {{ currentResult.metadata.publisher }} </span>
                    </div>
                  </div>
                  <div class="col-span-6 w-full">
                    <div class="text-base" v-if="currentResult.metadata && currentResult.metadata.description">
                      <span class="text-mpiwg-green">Description: </span>
                      <span> {{ currentResult.metadata.description }} </span>
                    </div>
                  </div>
                </div>
              </div>
              <div>
                <div class="grid grid-cols-12 w-full">

                </div>
              </div>
            </div>
          </div>
        </div>

        <!--<div
          class="flex flex-wrap mt-4"
          v-if="currentResult && currentResult.tags"
        >
          <span
            v-for="tag in currentResult.tags"
            @click="filterByTag(tag)"
            class="cursor-pointer break-keep shadow-md border border-mpiwg-brown bg-mpiwg-beige hover:bg-mpiwg-green hover:text-mpiwg-light-green text-sm text-mpiwg-green rounded px-2 py-1 mr-2 mt-2"
            >{{tag.name}} ({{tag.label}})</span
          >
        </div>!-->
      </div>
    </div>
  </div>
  <div class="col-span-12 grid place-items-center h-full bg-mpiwg-green">
    <div class="p-2 italic place-self-end text-white font-sans text-sm">
      A project from the
      <a href="https://mpiwg-berlin.mpg.de"
        class="font-mpiwg text-base font-semibold hover:text-mpiwg-light-green hover:underline" target="_blank">Max
        Planck Institute for the History of Science</a>
    </div>
  </div>
</div>
<script type="text/x-template" id="pagination">

  <button
    type="button"
    class="bg-mpiwg-beige w-full px-3 py-2 ml-0 border border-l-0 border-b-0 border-r-0 border-mpiwg-brown 0 hover:bg-white hover:disabled:bg-mpiwg-beige hover:text-gray-700 disabled:opacity-50"
    @click="onClickFirstPage"
    :disabled="isInFirstPage"
    aria-label="Go to first page"
  >
  <i class="fa-solid fa-angles-left"></i>
  </button>

  <button
    type="button"
    @click="onClickPreviousPage"
    :disabled="isInFirstPage"
    aria-label="Go to previous page"
    class="bg-mpiwg-beige w-full px-3 py-2 border-r-0 border border-b-0 border-mpiwg-brown hover:text-gray-700 0 hover:bg-white hover:disabled:bg-mpiwg-beige disabled:opacity-50"
  >
   <i class="fa-solid fa-angle-left"></i>
  </button>

  <button v-for="page in pages"
    type="button"
    @click="onClickPage(page.name)"
    :disabled="page.isDisabled"
    :class="{ active: isPageActive(page.name) }"
    :aria-label="`Go to page number ${page.name}`"
    class="bg-mpiwg-beige w-full px-3 py-2 border border-r-0 border-b-0 border-mpiwg-brown hover:text-gray-700 0 hover:bg-white hover:disabled:bg-mpiwg-green disabled:hover:text-mpiwg-light-green"

  >
    {{ page.name }}
  </button>
  <button
    type="button"
    @click="onClickNextPage"
    :disabled="isInLastPage"
    aria-label="Go to next page"
    class="bg-mpiwg-beige w-full px-3 py-2 border border-r-0 border-b-0 border-mpiwg-brown hover:text-gray-7000 hover:bg-white hover:disabled:bg-mpiwg-beige disabled:opacity-50 hover:disabled:opacity-50"
  >
   <i class="fa-solid fa-angle-right"></i>
  </button>
  <button
    type="button"
    @click="onClickLastPage"
    :disabled="isInLastPage"
    class="bg-mpiwg-beige w-full px-3 py-2 border border-r-0 border-b-0 border-mpiwg-brown hover:text-gray-700 hover:bg-white hover:disabled:bg-mpiwg-beige disabled:opacity-50 hover:disabled:opacity-50"
    aria-label="Go to last page"
  >
   <i class="fa-solid fa-angles-right"></i>
  </button>
</script>
<script src="/static/combio_app/js/pagination.js"></script>
<script src="/static/combio_app/js/utils.js"></script>
<script>
  const app = Vue.createApp({
    components: {
      pagination: Pagination,
    },
    data() {
      return {
        sortBy: "date",
        sortOptions: [
          { label: "date, ascending", val: "date" },
          { label: "date, descending", val: "-date" },
          { label: "title, ascending", val: "title_kw" },
          { label: "title, descending", val: "-title_kw" },
        ],
        filterBookmarks: false,
        showCollectionFilter: false,
        loading: true,
        pageLoaded: false,
        panes: { combio: true, dc: false, other: false },
        total: 0,
        currentPage: 1,
        searchFocus: false,
        startRecord: "",
        perPage: 10,
        results: [],
        currentResult: {},
        collections: [],
        staffUser: staffUser,
        postHeaders: {
          "Content-Type": "application/json",
          "X-CSRFToken": csrfToken,
        },
        q: "",
      };
    },
    computed: {
      totalPages() {
        return Math.ceil(this.total / this.perPage);
      },
    },
    //watch: {
    //  // whenever question changes, this function will run
    //  currentResult: function (newResult, oldResult) {
    //    this.checkPermalink()
    //  }
    //},
    methods: {
      editLink(record) {
        return "/admin/combio_app/record/" + record.id + "/change/";
      },
      resetForm() {
        this.q = "";
        this.currentPage = 1;
        this.filterBookmarks = false;
        this.collections.forEach(function (col) {
          col.checked = true;
        });
        this.sortBy = "date";
        this.submitForm();
        this.$nextTick(() => {
          this.$refs.input.focus()
        })
      },
      filterByTag(tag) {
        this.q = tag.name;
        this.currentPage = 1;
        this.submitForm();
      },
      async setSort() {
        this.currentPage = 1;
        this.submitForm();
      },
      async toggleFilterBookmarks() {
        this.filterBookmarks = !this.filterBookmarks;
        this.currentPage = 1;
        this.submitForm();
      },
      async toggleCollectionFilter() {
        this.showCollectionFilter = !this.showCollectionFilter;
      },
      async setBookmark(result) {
        const data = { id: result.id };
        let method = "POST";
        if (result.bookmarked) {
          method = "DELETE";
        }
        await axios({
          method: method,
          url: "/api/user/records/",
          data: data,
          headers: this.postHeaders,
        }).then(async (response) => {
          console.log(response.data);
        });
        result.bookmarked = !result.bookmarked;
      },
      showDate(date) {
        if (!date) {
          return "no date";
        } else {
          const d = new Date(date);
          const options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric' };
          return d.toLocaleDateString('en-uk', options);
        }
      },
      togglePane(paneName) {
        this.panes[paneName] = !this.panes[paneName];
      },
      setCurrent(result) {
        this.currentResult = result;
        var newurl =
          window.location.protocol +
          "//" +
          window.location.host +
          window.location.pathname +
          "?record=" +
          result.id;
        window.history.pushState({ path: newurl }, "", newurl);
        top.document.title =
          "Commoning Biomedicine | " +
          result.title +
          ", " +
          result.collection.name;
        metaAdder("name=citation_author", result.collection.name);
      },
      isCurrent(result) {
        if (this.currentResult) {
          return result.id == this.currentResult.id;
        } else {
          return false;
        }
      },
      async onPageChange(page) {
        this.currentPage = page;
        await this.submitForm();
      },
      selectAll() {
        this.$refs.input.select();
      },
      async checkPermalink() {
        try {
          const response = await axios.get(this.currentResult.metadata.permalink, { timeout: 5000 }); // 5000 ms timeout
          if (response.status === 200) {
            console.log("Link is live");
          } else {
            console.log("Link is not live, status code:", response.status);
          }
        } catch (error) {
          if (error.code === 'ECONNABORTED') {
            console.log("Request timed out");
          } else if (error.response) {
            console.log("Link is not live, status code:", error.response.status);
          } else {
            console.log("An error occurred:", error.message);
          }
        }
      },
      async submitForm() {
        this.pageLoaded = false;
        let selectedCollections = this.collections.filter(
          (element) => element.checked
        );
        let data = {
          q: this.q,
          sort: this.sortBy,
          selected_collections: selectedCollections.map((c) => c.pk),
          b_on: this.filterBookmarks,
          per_page: this.perPage,
          page: this.currentPage,
        };
        await axios({
          method: "POST",
          url: "/api/search/",
          data: data,
          headers: this.postHeaders,
        }).then(async (response) => {
          this.results = response["data"]["results"];
          this.total = response["data"]["results_count"];
        });
        if (this.results.length > 0) {
          this.setCurrent(this.results[0]);
        } else {
          this.currentResult = null;
          var newurl =
            window.location.protocol +
            "//" +
            window.location.host +
            window.location.pathname;
          window.history.pushState({ path: newurl }, "", newurl);
          top.document.title = "Commoning Biomedicine";
        }
        this.pageLoaded = true;
      },
    },
    async created() {
      window.addEventListener("keydown", async (e) => {
        if (e.key == " " && this.currentResult && !this.searchFocus) {
          e.preventDefault();
          //this.currentResult.bookmarked = !this.currentResult.bookmarked
          this.setBookmark(this.currentResult);
        }
        if (
          e.key == "ArrowLeft" &&
          this.currentPage != 1 &&
          !this.searchFocus
        ) {
          e.preventDefault();
          this.onPageChange(this.currentPage - 1);
        }
        if (
          e.key == "ArrowRight" &&
          this.currentPage < this.totalPages &&
          !this.searchFocus
        ) {
          e.preventDefault();
          this.onPageChange(this.currentPage + 1);
        }
        if (e.key == "ArrowUp" && this.currentResult) {
          if (this.currentResult.index > 0) {
            e.preventDefault();
            this.setCurrent(
              this.results.find((r) => r.index == this.currentResult.index - 1)
            );
          } else {
            if (this.currentPage != 1) {
              e.preventDefault();
              await this.onPageChange(this.currentPage - 1);
              await this.setCurrent(
                this.results.find((r) => r.index == this.perPage - 1)
              );
            }
          }
        }

        if (
          e.key == "ArrowDown" &&
          this.currentResult &&
          this.total > 1 &&
          this.currentResult.index < this.total
        ) {
          if (this.currentResult.index < this.perPage - 1) {
            if (
              this.currentPage == this.totalPages &&
              this.currentResult.index == (this.total % this.perPage) - 1
            ) {
              // we reached the end, do nothing
            } else {
              e.preventDefault();
              this.setCurrent(
                this.results.find(
                  (r) => r.index == this.currentResult.index + 1
                )
              );
            }
          } else {
            e.preventDefault();
            await this.onPageChange(this.currentPage + 1);
          }
        }
      });
    },
    async mounted() {
      var urlToParse = location.search;
      var urlParams = parseQueryString(urlToParse);
      if (urlParams["record"]) {
        this.q = "record:" + urlParams["record"];
      }
      await axios.get("/api/collections").then(async (response) => {
        this.collections = response["data"]["collections"];
        this.collections = this.collections.map((c) =>
          Object.assign(c, { checked: true })
        );
      });
      await this.submitForm();
      this.loading = false;
    },
  }).mount("#app");
</script>
{% endverbatim %} {% endblock container %}